/*
 *
 *   Created for Abducted IRC by Anomaly
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include <time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef _WIN32
#include <io.h>
#endif
#include <fcntl.h>
#include "h.h"
#include "proto.h"
#include "inet.h"
#ifdef STRIPBADWORDS
#include "badwords.h"
#endif
#ifdef _WIN32
#include "version.h"
#endif

DLLFUNC int m_uloper(aClient *cptr, aClient *sptr, int parc, char *parv[]);

static int _OldOperFlags[] = {
        OFLAG_LOCAL, 'o',
        OFLAG_GLOBAL, 'O',
        OFLAG_REHASH, 'r',
        OFLAG_DIE, 'D',
        OFLAG_RESTART, 'R',
        OFLAG_HELPOP, 'h',
        OFLAG_GLOBOP, 'g',
        OFLAG_WALLOP, 'w',
        OFLAG_LOCOP, 'l',
        OFLAG_LROUTE, 'c',
        OFLAG_GROUTE, 'L',
        OFLAG_LKILL, 'k',
        OFLAG_GKILL, 'K',
        OFLAG_KLINE, 'b',
        OFLAG_UNKLINE, 'B',
        OFLAG_LNOTICE, 'n',
        OFLAG_GNOTICE, 'G',
        OFLAG_ADMIN_, 'A',
        OFLAG_SADMIN_, 'a',
        OFLAG_NADMIN, 'N',
        OFLAG_COADMIN, 'C',
        OFLAG_ZLINE, 'z',
        OFLAG_WHOIS, 'W',
        OFLAG_HIDE, 'H',
        OFLAG_TKL, 't',
        OFLAG_GZL, 'Z',
        OFLAG_OVERRIDE, 'v',
        OFLAG_UMODEQ, 'q',
        OFLAG_DCCDENY, 'd',
        OFLAG_ADDLINE, 'X',
        0, 0
};
/* Place includes here */
#define MSG_ULOPER        "ULOPER"
#define TOK_ULOPER        "TZ"

typedef struct oper_oflag_ {
	unsigned long oflag;
	long* umode;	/* you just HAD to make them variables */
	char** host;
	char* announce;
} oper_oflag_t;

static oper_oflag_t oper_oflags[10]; 

static void init_operflags()
{
	oper_oflags[0].oflag = OFLAG_NETADMIN;
	oper_oflags[0].umode = &UMODE_NETADMIN;
	oper_oflags[0].host = &netadmin_host;
	oper_oflags[0].announce = "is now a network administrator (N)";
	oper_oflags[1].oflag = OFLAG_SADMIN;
	oper_oflags[1].umode = &UMODE_SADMIN;
	oper_oflags[1].host = &sadmin_host;
	oper_oflags[1].announce = "is now a services administrator (a)";
	oper_oflags[2].oflag = OFLAG_ADMIN;
	oper_oflags[2].umode = &UMODE_ADMIN;
	oper_oflags[2].host = &admin_host;
	oper_oflags[2].announce = "is now a server admin (A)";
	oper_oflags[3].oflag = OFLAG_COADMIN;
	oper_oflags[3].umode = &UMODE_COADMIN;
	oper_oflags[3].host = &coadmin_host;
	oper_oflags[3].announce = "is now a co administrator (C)";
	oper_oflags[4].oflag = OFLAG_ISGLOBAL;
	oper_oflags[4].umode = &UMODE_OPER;
	oper_oflags[4].host = &oper_host;
	oper_oflags[4].announce = "is now an operator (O)";
	oper_oflags[5].oflag = OFLAG_HELPOP;
	oper_oflags[5].umode = &UMODE_HELPOP;
	oper_oflags[5].host = NULL;
	oper_oflags[5].announce = NULL;
	oper_oflags[6].oflag= OFLAG_GLOBOP;
	oper_oflags[6].umode = &UMODE_FAILOP;
	oper_oflags[6].host = NULL;
	oper_oflags[6].announce = NULL;
	oper_oflags[7].oflag = OFLAG_WALLOP;
	oper_oflags[7].umode = &UMODE_WALLOP;
	oper_oflags[7].host = NULL;
	oper_oflags[7].announce = NULL;
	oper_oflags[8].oflag = OFLAG_WHOIS;
	oper_oflags[8].umode = &UMODE_WHOIS;
	oper_oflags[8].host = NULL;
	oper_oflags[8].announce = NULL;
	oper_oflags[9].oflag = 0;
	oper_oflags[9].umode = NULL;
	oper_oflags[9].host = NULL;
	oper_oflags[9].announce = NULL;
}
	

ModuleHeader MOD_HEADER(m_uloper)
  = {
	"uloper",	/* Name of module */
	"$Id: m_uloper.c,v 0.1 2006/03/03 Anomaly",
	"/uloper", /* Short description of module */
	"3.2-b8-1",
	NULL 
    };

DLLFUNC int MOD_INIT(m_uloper)(ModuleInfo *modinfo)
{
	/*
	 * We call our add_Command crap here
	*/
	add_Command(MSG_ULOPER, TOK_ULOPER, m_uloper, MAXPARA);
	return MOD_SUCCESS;
}

DLLFUNC int MOD_LOAD(m_uloper)(int module_load)
{
	init_operflags();
	return MOD_SUCCESS;
}

DLLFUNC int MOD_UNLOAD(m_uloper)(int module_unload)
{
	if (del_Command(MSG_ULOPER, TOK_ULOPER, m_uloper) < 0)
	{
		sendto_realops("Failed to delete commands when unloading %s",
				MOD_HEADER(m_uloper).name);
	}
	return MOD_SUCCESS;
}


/*
** m_uloper
**	parv[0] = sender prefix
**	parv[1] = user name
**	parv[2] = oflags
*/

DLLFUNC int  m_uloper(aClient *cptr, aClient *sptr, int parc, char *parv[]) {
	char *name;
	char *operflags;
	char* host = 0;
	int i = 0, j = 0;
	char* announce = 0;
	aClient *acptr;
	int already = 0;
	
	if (!IsULine(sptr) && !IsServer(sptr))
		return 0;

	if (parc < 3) {
		sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
		    me.name, parv[0], "ULOPER");
		return 0;
	}

	name = parv[1];
	operflags = parv[2];
        if (!(acptr = find_client(name, NULL))) {
		sendto_one(sptr, err_str(ERR_NOSUCHNICK),
                                    me.name, parv[0], name);
		return 0;
	}
	if (!MyClient(acptr)) {
		sendto_one(acptr, ":%s ULOPER %s %s", parv[0], parv[1], parv[2]);
                return 0;
	}
	if (IsAnOper(acptr)) {
		already = 1;
		if (IsNetAdmin(acptr))
                        ClearNetAdmin(acptr);
                if (IsSAdmin(acptr))
                        ClearSAdmin(acptr);
                if (IsAdmin(acptr))
                        ClearAdmin(acptr);
                if (IsHideOper(acptr))
                        ClearHideOper(acptr);
                if (IsCoAdmin(acptr))
                        ClearCoAdmin(acptr);
                if (IsHelpOp(acptr))
                        ClearHelpOp(acptr);
                if (IsCloaked(acptr))
                        acptr->umodes &= ~UMODE_CLOAKED;
                if (IsOper(acptr))
                        ClearOper(acptr);
                if (acptr->umodes & UMODE_LOCOP)
                        acptr->umodes &= ~UMODE_LOCOP;
	}
	int *a, flag;
	long flags = 0;
	char *m;
	for (m=operflags;*m;m++) {
	 if (*m == 'X') {
		acptr->flags |= FLAGS_STAFF;
		sendto_serv_butone(&me, ":%s STAFF %s", me.name, acptr->name);
	 }
	 for (a = _OldOperFlags; (flag = *a); a += 2)
                 if (*m == (char)(*(a + 1)))
                 {
                        flags |= flag;
                        break;
                 }
	}

		int  old = (acptr->umodes & ALL_UMODES);
	


		/* Put in the right class */

		acptr->oflag = 0;

			acptr->umodes |= OPER_MODES;

		
		while(oper_oflags[j].umode) {
			if(flags & oper_oflags[j].oflag) {	/* we match this oflag */
				if (!announce && oper_oflags[j].announce) { /* we haven't matched an oper_type yet */
					host = *oper_oflags[j].host;	/* set the iNAH host */
					announce = oper_oflags[j].announce; /* set the announcement */
				}
				acptr->umodes |= 
					*oper_oflags[j].umode; /* add the umode for this oflag */
			}
			j++;
		}

		acptr->oflag = flags;
		if ((flags & OFLAG_HIDE) && iNAH && !BadPtr(host)) {
			char *c;
			char *vhost = host;

			if ((c = strchr(host, '@')))
			{
				vhost =	c+1;
				strncpy(acptr->user->username, host, c-host);
				acptr->user->username[c-host] = 0;
				sendto_serv_butone_token(NULL, acptr->name, MSG_SETIDENT, 
							 TOK_SETIDENT, "%s", 
							 acptr->user->username);
			}
			iNAH_host(acptr, vhost);
			SetHidden(acptr);
		} else
		if (IsHidden(acptr) && !acptr->user->virthost) {
			/* +x has just been set by modes-on-oper and iNAH is off */
			acptr->user->virthost = (char *)make_virthost(acptr->user->realhost,
			                                             acptr->user->virthost, 1);
		}

		if (!IsOper(acptr))
		{
			acptr->umodes |= UMODE_LOCOP;
			if ((flags & OFLAG_HIDE) && iNAH && !BadPtr(locop_host)) {
				iNAH_host(acptr, locop_host);
				SetHidden(acptr);
			}
			sendto_ops("%s (%s@%s) is now a local operator (o)",
			    parv[1], acptr->user->username, GetHost(acptr));
		}

		if (announce != NULL)
			sendto_snomask_global(SNO_OPER,
			    "%s (%s@%s) [%s] %s",
			    parv[1], acptr->user->username, GetHost(acptr),
			    parv[1], announce);
		if (acptr->user->operlogin)
			MyFree(acptr->user->operlogin);
		acptr->user->operlogin = strdup("the ULoper system");

		sendto_serv_butone_token(&me,
			acptr->name, "OPERLOGIN", "ZM",
			"%s :%s", sptr->name, strdup("the ULoper system"));
 		set_snomask(acptr, OPER_SNOMASK);
		if (acptr->user->snomask)
		{
			acptr->user->snomask |= SNO_SNOTICE; /* set +s if needed */
			acptr->umodes |= UMODE_SERVNOTICE;
		}
		/* This is for users who have both 'admin' and 'coadmin' in their conf */
		if (IsCoAdmin(acptr) && IsAdmin(acptr))
		{
			acptr->umodes &= ~UMODE_COADMIN;
			acptr->oflag &= ~OFLAG_COADMIN;
		}
		send_umode_out(acptr, acptr, old);
		sendto_one(acptr, rpl_str(RPL_SNOMASK),
			me.name, parv[1], get_sno_str(acptr));

#ifndef NO_FDLIST
		if (!already) {
			addto_fdlist(acptr->slot, &oper_fdlist);
		}
#endif
		RunHook2(HOOKTYPE_LOCAL_OPER, acptr, 1);
		sendto_one(acptr, rpl_str(RPL_YOUREOPER), me.name, parv[1]);
		if (IsInvisible(acptr) && !(old & UMODE_INVISIBLE))
			IRCstats.invisible++;
		if (IsOper(acptr) && !IsHideOper(acptr))
			IRCstats.operators++;

		if (SHOWOPERMOTD == 1)
			do_cmd(cptr, acptr, "OPERMOTD", parc, parv);
		ircd_log(LOG_OPER, "ULOPER (%s) by (%s!%s@%s)", name, parv[1], acptr->user->username,
			acptr->sockhost);

	return 0;
}
